
#
#  - CHATTERS ver 1.00 / Feb 15, 2007 / Freesoft
#  - (C)2007 WEB POWER. All Rights Reserved. <http://webpower.jp/>
#

use strict;

#================================================================================
#  Check ROM (for WEB Beacon)
#
#	  Called : main
#	  Params : none
#	  Return : exit
#================================================================================

sub Check_Roms #(void)
{

	## LOCAL VARS
	my($chat_file);


	$::INI{'check_rom'} = $::INI{'check_rom'};

	if ($::INI{'check_rom'}) {

		checkChatRoom();
		$chat_file = $::SYS{'CHAT_DIR'} . getFilename();

		if (!$::SYS{'USE_LOCK'} || stdio::lock($::LOCK_FILE, 1)) {
			my($atime, $mtime) = (stat $chat_file)[8,9];
			if (open IN, $chat_file) {
				my(@chat_data, @roms, @new_roms, $crypt_ip, $roms, $time, $flag, $line, $tmp_file, $i);

				#  Read file
				while (<IN>) {
					$line = $i if (!$line && index($_, "<!--ROM-->") != -1);
					push @chat_data, $_;
					$i ++;
				}
				close IN;

				$crypt_ip = crypt(sprintf("%02X%02X%02X%02X", split(/\./, $ENV{'REMOTE_ADDR'})), "IP");
				$time = time;

				#  Get ROM data (<!--,CSV,-->)
				@roms = split /,/, $chat_data[1];

				#  Remove "<!--" and "-->"
				shift @roms;
				pop   @roms;

				#  Check ROM
				foreach (@roms) {
					my($crypt_ip2, $time2) = split /=/;

					#  Requested IP ?
					if ($crypt_ip eq $crypt_ip2) {
						push @new_roms, "$crypt_ip=$time";
						$flag = 1;

					#  Not access more than 5 mins => Remove from ROM list
					} elsif ($time - $time2 <= 300) {
						push @new_roms, "$crypt_ip2=$time2";
					}
				}

				#  Add requested user's IP to ROM list
				push @new_roms, "$crypt_ip=$time" if (!$flag && $#roms < 64);

				$roms = @new_roms ? $#new_roms + 1 : 0;
				$chat_data[$line] =~ s/<!--ROM-->.+<!--\/ROM-->/<!--ROM--><!--\/ROM-->/;
				$chat_data[$line] =~ s/<!--ROM--><!--\/ROM-->/<!--ROM-->*ROM($romsl)<!--\/ROM-->/;
				$chat_data[1] = "<!--," . join(",", @new_roms) . ",-->\n";

				#  Write to templolary file => Rename
				$tmp_file = "$chat_file$$.tmp";
				if (open OUT, ">$tmp_file") {
					print OUT @chat_data;
					close OUT;
					if (!rename $tmp_file, $chat_file) {
						unlink $tmp_file;
					}
				}
			}
			stdio::unlock($::LOCK_FILE);

			utime $atime, $mtime, $chat_file;
		}
	}

	bincmd STDOUT;

	#  Output Clear GIF
	print "Content-Type: image/gif\n"
		. "Content-Length: 29\n"
		. "Cache-Control: no-cache\n"
		. "Pragma: no-cache\n"
		. "\n";

	foreach (qw(47 49 46 38 39 61 01 00 01 00 91 ff 00 ff ff ff 00 00 00 c0
				c0 c0 00 00 00 21 f9 04 01 00 00 02 00 2c 00 00 00 00 01 00
				01 00 40 02 02 54 01 00 3b)) {
		print pack('C*', hex($_));
	}

	exit;

}#checkRoms

1;
